// package ???;

import java.util.*;


/**
 * Nachbau des Java-StringTokenizers,
 * aber mit Trenn-String statt Trenn-Zeichen.
 */
public class HeinerStringTokenizer {

    /**
     * Zerlegen eines Strings in Token . <br>
     * Nachbau des Java-StringTokenizers,
     * aber mit Trenn-String statt Trenn-Zeichen.
     *
     * @param strPaValue    zu zerteilender String
     * @param strPaDelim    Trenn-String, Achtung keine Sammlung von Trennzeichen wie beim StringTokenizer
     * @param bPaInclDelim  ob das Trenn-String mit in die Ergebnis-Tokens geliefert werden soll
     * @author Heiner Kcker
     */
    public static String[] tokenize(
        final String strPaValue,
        final String strPaDelim,
        final boolean bPaInclDelim)
    {
        if (strPaValue == null)
        {
            return null;
        }

        ArrayList arrList = new ArrayList();

        if (strPaDelim == null)
        {
            return new String[] { strPaValue };
        }

        int iPos = 0;

        while (iPos < strPaValue.length())
        {
            // System.out.println( "indexOf( " + strPaDelim + " , " + iPos + " ): " + strPaValue.indexOf( strPaDelim , iPos ) ) ;
            if (strPaValue.indexOf(strPaDelim, iPos) < 0)
            {
                // Delimiter nicht mehr enthalten
                // Rckgabe des Restes vom String
                arrList.add(strPaValue.substring(iPos));
                iPos = strPaValue.length(); // ans Ende setzen fr evtl. weitere Auswertungen
                break;
            }
            else
            {
                // Delimiter enthalten
                if (strPaValue.startsWith(strPaDelim, iPos))
                { // ab Position
                    // Beginn mit Delimiter
                    if (bPaInclDelim)
                    {
                        arrList.add(strPaDelim);
                    }
                    iPos += strPaDelim.length();
                }
                else
                {
                    // Beginn mit Token (Teilstck)
                    int iEndPos = strPaValue.indexOf(strPaDelim, iPos); // evtl. - 1 ;
                    // jetzt kommt es darauf an, ob angabe iEndPos absolut oder relativ ist
                    // arrList.add( strPaValue.substring( iPos , endpos oder lnge ) ) ;
                    String strTmp = strPaValue.substring(iPos, iEndPos);

                    // System.out.println( "*" + strTmp ) ;
                    arrList.add(strTmp);
                    iPos += strTmp.length(); // = iEndPos ; // oder += iEndPos
                }
            } // end if
        } // end while
        return (String[]) arrList.toArray( new String[ arrList.size() ] );
    } // end method tokenize

  /**
   * Test
   */
  public static void main(String[] args) {
    String strTest = "LineNr:aaa LineNr: aaa LineNr:LineNr: ccc LineNr: dddLineNr:beeeLineNr:";

    System.out.println(strTest);
    // ArrayList arrList = tokenize( strTest , ";" , true ) ;
    // out( arrList ) ;
    out(tokenize(strTest, "LineNr:", true));
    System.out.println("");
    out(tokenize(strTest, "LineNr:", false));
  }// end method

  /**
   * Ausgabe String-Array
   */
  public static void out(String[] arrStr) {
    System.out.println("out count:" + arrStr.length);
    for (int i = 0; i < arrStr.length; i++) {
      System.out.println("|" + arrStr[ i ] + "|");
    }// end for
  }// end method main

}
// end class
